﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public BANano As BANano
	Public alaSQL As BANanoSQL
	Public Results As List 
End Sub

Sub InitWait
	Results.Initialize 
	'create a div
	Dim el As BANanoElement
	el = BANano.GetElement("#body")
	el.empty
	el.Append($"<button id="btnadd">Create FLight</button><br>"$)
	el.Append($"<button id="btnread">Read FLight</button><br>"$)
	el.Append($"<button id="btnupdate">Update FLight</button><br>"$)
	el.Append($"<button id="btndelete">Delete FLight</button><br>"$)
	el.Append($"<button id="res">Flights</button>"$)
	alaSQL.OpenWait("SQL", "flightsdb")
	Dim flights As Map
	flights.Initialize
	flights.Put("flightNo", modDB.DB_INT)
	flights.Put("fromCity", modDB.DB_STRING)
	flights.Put("toCity", modDB.DB_STRING)
	flights.Put("isInTheAir", modDB.DB_BOOL)
	Dim sql As String = modDB.CreateTableSQL("flights",flights,"flightNo")
	alaSQL.Executewait(sql, Null)
	BANano.GetElement("#btnadd").HandleEvents("click", Me, "btnadd_click")
	BANano.GetElement("#btnread").HandleEvents("click", Me, "btnread_click")
	BANano.GetElement("#btnupdate").HandleEvents("click", Me, "btnupdate_click")
	BANano.GetElement("#btndelete").HandleEvents("click", Me, "btndelete_click")
End Sub

Sub btndelete_click(event As BANanoEvent)
	Log(event.ID)
	DeleteFlightWait(1)
	SelectFlightWait(1)
	Log(Results)
End Sub

Sub btnread_click(event As BANanoEvent)
	Log(event.ID)
	SelectFlightWait(1)
	Log(Results)
End Sub

Sub btnupdate_click(event As BANanoEvent)
	Log(event.ID)
	UpdateFlightWait(1)
	SelectFlightWait(1)
	Log(Results)
End Sub

Sub btnadd_click(event As BANanoEvent)
	Log(event.ID)
	SelectFlightWait(1)
	If Results.Size = 0 Then
		InsertFlightWait(1)
	End If
	SelectFlightWait(1)
	Log(Results)
End Sub

'should be specific to project
Sub InsertFlightWait(fn As Int)
	Dim flights As Map
	flights.Initialize
	flights.Put("flightNo", fn)
	flights.Put("fromCity", "Brussels")
	flights.Put("toCity", "Paris")
	flights.Put("isInTheAir", True)
	Dim sqlm As Map = modDB.InsertSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	alaSQL.Executewait(sql, values)
End Sub

Sub SelectFlightWait(fn As Int)
	Dim flights As Map = CreateMap("flightNo": fn)
	Dim sqlm As Map = modDB.SelectWhereSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	Results = alaSQL.ExecuteWait(sql, values)
End Sub

'should be specific to project
Sub UpdateFlightWait(fn As Int)
	'fields to update
	Dim flights As Map
	flights.Initialize
	flights.Put("fromCity", "Paris")
	flights.Put("toCity", "Brussels")
	flights.Put("isInTheAir", False)
	'select this one
	Dim wherem As Map
	wherem.Initialize
	wherem.Put("flightNo", fn)
	Dim sqlm As Map = modDB.UpdateWhereSQLMap("flights", flights, wherem)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	alaSQL.ExecuteWait(sql, values)
End Sub


Sub DeleteFlightWait(fn As Int)
	'please note the operator =
	Dim flights As Map = CreateMap("flightNo =": fn)
	Dim sqlm As Map = modDB.DeleteWhereSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	alaSQL.ExecuteWait(sql, values)
End Sub

Sub UpdateAllFlightsWait
	'fields to update
	Dim flights As Map
	flights.Initialize
	flights.Put("fromCity", "East London")
	flights.Put("toCity", "Israel")
	flights.Put("isInTheAir", True)
	Dim sqlm As Map = modDB.UpdateSQLMap("flights", flights)
	Dim sql As String = sqlm.Get("sql")
	Dim values As List = sqlm.Get("values")
	alaSQL.ExecuteWait(sql, values)
End Sub